//
//  JumpSystemPlugin.m
//  RN-plugin
//
//  Created by 初程程 on 2018/6/21.
//  Copyright © 2018年 初程程. All rights reserved.
//

#import "JumpSystemPlugin.h"
#import <UIKit/UIKit.h>
@implementation JumpSystemPlugin
+ (void)jumpToSystemSettingWithType:(SettingType)type
                         completion:(void(^)(BOOL isSuccess))completion{
//    App-Prefs:root=Bluetooth
//    App-Prefs:root=Bluetooth
//App-Prefs:root=General&path=Bluetooth
    NSString *urlString = [self getUrlWithType:type];
    
    [self jumpToSystemSettingWithUrl:urlString completion:completion];
}
+ (void)jumpToSystemSettingWithUrl:(NSString *)urlString
                        completion:(void(^)(BOOL isSuccess))completion{
    NSURL *url = [NSURL URLWithString:urlString];
    
    UIApplication *application = [UIApplication sharedApplication];
    //iOS 10以上用新方法  如果兼容到iOS 10 可只用第一个方法
    if ([application respondsToSelector:@selector(openURL:options:completionHandler:)]) {
//        [application openURL:url options:@{} completionHandler:^(BOOL success) {
//            completion(success);
//        }];
        BOOL isSuccess = [application canOpenURL:url];
        if (isSuccess) {
            [application openURL:url];
        }
    }else{
        BOOL isSuccess = [application canOpenURL:url];
        if (isSuccess) {
            [application openURL:url];
        }
        completion(isSuccess);
    }
}
+ (NSString *)getUrlWithType:(SettingType)type{
    NSString *version= [UIDevice currentDevice].systemVersion;
    
    double value = [version doubleValue];
    
    NSString *typeString = @"";
    NSString *titleString = @"";
    if (value>=10) {
        titleString = @"App-Prefs";
    }else{
        titleString = @"prefs";
    }
    switch (type) {
            
        case WIFI:
            typeString = @"root=WIFI";
            break;
        case AppSet:
            return UIApplicationOpenSettingsURLString;
            break;
        case Bluetooth:
            typeString = @"root=General&path=Bluetooth";
            break;
        case Notify:
            typeString = @"root=NOTIFICATIONS_ID";
            break;
        default:
            break;
    }
    return [NSString stringWithFormat:@"%@:%@",titleString,typeString];
}

@end
