//
//  RCTNativePlugin.m
//  RCTNativePlugin
//
//  Created by 初程程 on 2018/6/27.
//  Copyright © 2018年 初程程. All rights reserved.
//

#import "RCTNativePlugin.h"
#import "JumpSystemPlugin.h"
#import <CoreTelephony/CTCellularData.h>
#import <UserNotifications/UserNotifications.h>

@interface RCTNativePlugin()
@property (nonatomic ,copy)RCTPromiseResolveBlock resolve;
@property (nonatomic ,copy)RCTPromiseRejectBlock rejecter;
@end
@implementation RCTNativePlugin
RCT_EXPORT_MODULE(NativePluginReactPackage);

RCT_EXPORT_METHOD(isNotifycationOpen:(NSString *)arg resolve:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock)rejecter){
    _resolve = resolve;
    _rejecter = rejecter;
    [self checkPush:^(NSString *tip, UIUserNotificationType type) {
        _resolve(tip);
    }];
}
RCT_EXPORT_METHOD(openNotifycationSetting:(NSString *)arg resolve:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock)rejecter){
    _resolve = resolve;
    _rejecter = rejecter;
    [JumpSystemPlugin jumpToSystemSettingWithType:Notify completion:^(BOOL isSuccess) {
        _resolve(@YES);
    }];
}
RCT_REMAP_METHOD(openAppSetting, appResolve:(RCTPromiseResolveBlock)resolve appRejecter:(RCTPromiseRejectBlock)rejecter){
    [JumpSystemPlugin jumpToSystemSettingWithType:AppSet completion:^(BOOL isSuccess) {
        if (isSuccess) {
            resolve(@YES);
        }else{
            rejecter(@"500",@"",nil);
        }
    }];
    
}
RCT_REMAP_METHOD(openWifiSetting, wifiResolve:(RCTPromiseResolveBlock)resolve wifiRejecter:(RCTPromiseRejectBlock)rejecter){
    [JumpSystemPlugin jumpToSystemSettingWithType:WIFI completion:^(BOOL isSuccess) {
        if (isSuccess) {
            resolve(@"");
        }else{
            rejecter(@"500",@"",nil);
        }
    }];
}
RCT_REMAP_METHOD(openBluetoothSetting, blueResolve:(RCTPromiseResolveBlock)resolve blueRejecter:(RCTPromiseRejectBlock)rejecter){
    [JumpSystemPlugin jumpToSystemSettingWithType:Bluetooth completion:^(BOOL isSuccess) {
        if (isSuccess) {
            resolve(@"");
        }else{
            rejecter(@"500",@"",nil);
        }
    }];
}
- (void)checkPush:(void(^)(NSString *tip ,UIUserNotificationType type))completion{
    __block NSString *tip = @"";
    dispatch_async(dispatch_get_main_queue(), ^{
        if (@available(iOS 10, *)){
            UNUserNotificationCenter * center = [UNUserNotificationCenter currentNotificationCenter];
            center.delegate = self;
            [center requestAuthorizationWithOptions:UNAuthorizationOptionAlert | UNAuthorizationOptionBadge | UNAuthorizationOptionSound completionHandler:^(BOOL granted, NSError * _Nullable error) {
                
                if (granted) {
                    tip = @"打开";
                }else{
                    tip = @"没打开";
                }
                completion(tip,0);
            }];
            
        }else{
            UIUserNotificationSettings *settings = [[UIApplication sharedApplication] currentUserNotificationSettings];
            
            if (settings.types == UIUserNotificationTypeNone){
                tip = @"没打开";
            }else if (settings.types == UIUserNotificationTypeAlert){
                tip = @"alert权限";
            }else if (settings.types == UIUserNotificationTypeBadge){
                tip = @"badge权限";
            }else if (settings.types == UIUserNotificationTypeSound){
                tip = @"sound权限";
            }else{
                tip = @"未知";
            }
            
            completion(tip,settings.types);
        }
    });
}

- (dispatch_queue_t)methodQueue{
    return dispatch_get_main_queue();
}
@end
